#!/usr/bin/env python2
from scipy import *
import numpy as np
import sys, os
import subprocess
import pylab, matplotlib
from matplotlib.image import BboxImage
from matplotlib.transforms import Bbox, TransformedBbox, \
       blended_transform_factory, Affine2D, ScaledTranslation
from mpl_toolkits.axes_grid.inset_locator import inset_axes
import load
#cdict = {'red': ((0.0,0.0,0.0),(1.0,1.0,1.0)), 'green': ((0.0,0.0,0.0),(1.0,0.0,0.0)), 'blue': ((0.0,1.0,1.0),(1.0,0.0,0.0))}
cdict = {'red':   ((0.0,0.0,0.0),
                   (0.5,0.0,0.0),
                   (1.0,1.0,1.0)), 
         'green': ((0.0,1.0,1.0),
                   (0.5,0.0,0.0),
                   (1.0,0.0,0.0)), 
         'blue':  ((0.0,0.0,0.0),
                   (0.5,1.0,1.0),
                   (1.0,0.0,0.0))}
rbcmap = matplotlib.colors.LinearSegmentedColormap('redblue',cdict,256)
pylab.rcParams['text.usetex'] = True
pylab.rcParams['savefig.dpi'] = 300

def nrm(x,dx):
    return x/(sum(x)*dx)

dat = loadtxt(sys.argv[1])
x = dat[:,0]
dat_dx = dat[1,0] - dat[0,0]
dx = dat_dx
xbins = r_[x[0]-dx/2, x+dx/2]
n,i = nrm(dat[:,1],dat_dx), nrm(dat[:,2],dat_dx)#neutral, intergenic

em = loadtxt(sys.argv[2])
sites = load.loadSites(sys.argv[3], names='ACGT')[0]
energies = load.getEnergies(sites, em)
h = histogram(energies, bins=xbins, normed=True)[0]# boundhist

ax = pylab.axes()
pylab.semilogy(x, n, '-k')
pylab.semilogy(x, i, '--k')
trans = blended_transform_factory(ax.transData, ax.transAxes)

old_settings = seterr(all='ignore')
pctdev = (i-n)/n
seterr(**old_settings)
#vmax = max(abs(pctdev))*100
#vmin = -vmax
#pctdev = pctdev/max(pctdev)/2 + 0.5
vmax = 50
vmin = -vmax
pctdev = pctdev + 0.5
colors = [rbcmap(v) if not isnan(v) else (1,1,1,1) for v in pctdev]
t = Affine2D([[1,0,0],[0,0.05,0], [0,0,0]]) + trans
b = pylab.bar(x-dx/2, ones(len(x)), width=dx+0.02, transform=t, color=colors, bottom=0, ec='none', lw=0, aa=False)
#for p in b.patches:
#    p.set_rasterized(True)
#    p.set_antialiased(False)

t = Affine2D([[1,0,0],[0,0.2/np.max(h),0.05], [0,0,1]]) + trans
pylab.bar(x-dx/2, h, width=dx, transform=t, color='w', bottom=0)

pylab.xlim(xbins[0],xbins[-1])
pylab.ylim(0,0.2)
pylab.ylim(1e-6,0.2)
pylab.ylabel('Probability')
pylab.xlabel('$E$')

sm = matplotlib.cm.ScalarMappable(cmap=rbcmap, norm=matplotlib.colors.Normalize(vmin=vmin, vmax=vmax))
sm._A = []
cax = pylab.axes((0.6, 0.2, 0.2, 0.04))
cax.set_xticks([vmin, 0, vmax])
cax.set_xticks([])
cax.set_yticks([])
cb = pylab.colorbar(sm, cax=cax, orientation='horizontal', ticks=[vmin, 0, vmax], format=r'$%.3g$')
cb.solids.set_rasterized(True) 
cb.solids.set_antialiased(False)

pylab.savefig(sys.argv[4])
#pylab.show()
