#!/usr/bin/env python2
from scipy import *
from load import getEnergies, loadSites
from getDist import getEs, getEBins, getPaDpa
import sys, os
import string
from numpy import min,max
import pylab

def nrmlz(x, dx):
    return x/(sum(x)*dx)

def seq2Num(seqs, nbases=4):
    nseq,seqLen = seqs.shape
    return sum(seqs*(nbases**arange(seqLen)[::-1]),1).astype(int)

def dx(x):
    return x[1]-x[0]

def getIN(intergenicfile, em, nbins):
    names = 'ACGT'

    intergenic = loadSites(intergenicfile, 'ACGT')[0].flatten()
    pa,dpac = getPaDpa(intergenic)
    seqLen, nBases = em.shape
    
    seqnums = []
    for i in range(seqLen):
        l = (len(intergenic)-i)//seqLen
        
        p = intergenic[i:i+seqLen*l].reshape(l, seqLen)
        seqnums.append(seq2Num(p))
        p = (nBases-1-intergenic[i:i+seqLen*l][::-1]).reshape(l, seqLen)
        seqnums.append(seq2Num(p))
    seqnums = concatenate(seqnums)

    ens, probs = getEs(em, pa, dpac)
    x,dx,xbins = getEBins(em, nbins)

    hi = histogram(ens[seqnums], bins=xbins)[0]
    hn = histogram(ens, weights=probs, bins=xbins)[0]

    return x, dx, xbins, hn, hi

def main():
    intergenicf = sys.argv[1]
    em = loadtxt(sys.argv[2])
    nbins = int(sys.argv[3])

    sem = em[sum(abs(em),1) != 0,:]

    x, dx, xbins, hn, hi = getIN(intergenicf, sem, nbins)
    savetxt(sys.stdout, c_[x,hn,hi])

if __name__ == '__main__':
    main()
