#!/usr/bin/env python2
from scipy import *
import sys

def getTheoryDistribution(em, pa=None):
    if pa == None:
        ei = mean(em, 1)
        meanE = sum(ei)
        chi = sqrt(sum(mean((em - ei[:,newaxis])**2, 1)))
        return meanE, chi
    
    pa = array(pa)/sum(pa)
    ei = sum(pa*em, 1)
    meanE = sum(ei)
    chi = sqrt(sum(sum(pa*(em - ei[:,newaxis])**2, 1)))
    return meanE, chi

def renormalize(em, pa=None):
    if pa == None:
        em = (em.T - mean(em,1)).T
    else:
        pa = array(pa)/sum(pa)
        em = (em.T - sum(pa*em,1)).T
    chi = getTheoryDistribution(em, pa)[1]
    #chi = sqrt(sum(sum(pa*em**2, 0)))
    em = em/chi
    return em

if __name__ == '__main__':
    em = loadtxt(sys.argv[1])
    pa = None
    if len(sys.argv) > 2:
        pa = array([float(x) for x in sys.argv[2:6]])
    if sys.argv[-1] == 'r':
        savetxt(sys.stdout, renormalize(em, pa))
    else:
        print getTheoryDistribution(em, pa)
