#!/usr/bin/env python2
from scipy import *
import sys, os, glob, re
import pylab
from scipy.stats import pearsonr

def main():
    tfdir = sys.argv[1]
    tf = os.path.basename(tfdir)
    print >>sys.stderr, "{} PSAMS:".format(tf)

    motif_fns = glob.glob(os.path.join(tfdir, 'MatrixREDUCE', '*.affinity'))
    corrs = []
    for m in motif_fns:
        with open(m) as f:
            data = [l.split() for l in f.readlines()[1:]]    
            r,occ,olig = [array(a) for a in zip(*[(float(a), float(b), int(c)) for a,b,c in data])]
        
        corrs.append((os.path.basename(m), pearsonr(r, occ)[0]**2))
    corrs.sort(key=lambda x: x[1], reverse=True)
    for c in corrs:
        print >>sys.stderr, "{}: {}".format(c[0], c[1])

    with open(os.path.join(tfdir, 'MatrixREDUCE', re.sub('affinity', 'psam', corrs[0][0]))) as f:
        PSAM = array([[float(x) for x in l.split()[1:]] 
                                        for l in f.readlines()[5:]])
        em = -log(PSAM)/1.688
        savetxt(sys.stdout, em, '%.20f')
    print >>sys.stderr, ""

if __name__ == '__main__':
    main()
