#!/usr/bin/env python2
from __future__ import with_statement
from scipy import *
import pylab
import sys, re, os

def main():
    tf = os.path.basename(sys.argv[1])

    with open(sys.argv[1]) as f:
        regulated = [l.split('\t') for l in f.readlines()]
    regulatedgenes = set([gene for gene, pos, dist, site in regulated])

    with open('./Deletion/Regression_Tc1_hom.txt') as f:
        data = [l.split('\t') for l in f.readlines()]

        #gene, orf, no. of probes, measurments, F-statistic, -log(p-value), difference, YPD, YPDGE, YPG, YPE, YPL
        rates = dict([(d[0], min([float(x) for x in d[7:12]])) for d in data[1:] if len(d) > 5 and not d[-1].isspace()])
        rates.update(dict([(d[1], min([float(x) for x in d[7:12]])) for d in data[1:] if len(d) > 5 and not d[-1].isspace()]))
        essential = set([d[0] for d in data[1:] if not (len(d) > 5 and not d[-1].isspace())])
        essential.update([d[1] for d in data[1:] if not (len(d) > 5 and not d[-1].isspace())])
        tested = set([d[0] for d in data[1:]])
        tested.update([d[1] for d in data[1:]])

    #load gene to  TFBS map
    with open('tf_gene_map') as f:
        tf2gene = dict([l.split() for l in f.readlines()])

    if tf not in tf2gene:
        print >>sys.stderr, "{} unknown gene!".format(tf)
        sys.exit(1)

    with open('genenames') as f:
        altnames = [set(l.split()) for l in f.readlines()]
        for names in altnames:
            if essential & names:
                essential.update(names)
            if tested & names:
                tested.update(names)
    essentialsite = []
    nonessentialsite = []
    for gene in regulatedgenes:
        if gene in essential:
            essentialsite.append(site.strip())
        elif gene in tested:
            nonessentialsite.append(site.strip())
    
    print "{} is {} and regulates:".format(tf, 
                    'essential' if tf2gene[tf] in essential else 'nonessential')
    print "{} essential genes\n{} nonessential genes\n{} unknown".format(
                   len(essentialsite), len(nonessentialsite), len(regulated) - len(essentialsite) - len(nonessentialsite))

if __name__ == '__main__':
    main()

